/*
 * News Leech + Decode functions for PIMPPA
 *
 * by ~g / RRR S0R0R1TY Division
 *
 *
 * Uses: suck, uudeview
 *
 *
 */

#include <errno.h>
#include <time.h>
#include <ctype.h>
#include <dirent.h>
#include <fcntl.h>
#include <getopt.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/vfs.h>
#include <regex.h>

#include "pimppa.h"
#include "adopt.h"
#include "dupecheck.h"
#include "news.h"
#include "md5.h"

char NNTPServer[BUFFSIZE];			// NNTP Server name
char GroupString[255];				// To match newsgroups

int Nazi=0;							// Only accept files w/ predefined pattern
int Verbose=0;

int GainedFiles=0;

extern MYSQL src_db, dst_db;

char *Results[]={"File ok",
    "Filename length is larger than allowed",
    "Invalid filename",
    "File exists",
    "Assigns tell to delete",
    "Nazi tells to delete (assign unknown)"};

#define RESULT_OK                   0
#define RESULT_LONG_FILENAME        1
#define RESULT_INVALID_FILENAME     2
#define RESULT_FILE_EXISTS          3
#define RESULT_ASSIGN_DELETE        4
#define RESULT_NAZI_KILL            5

// This is what we currently think important in a news message
struct newsmsg
{
	char *subject;
	char *id;
};

char Filetypes[1024];

#define TMP_MSGS	"messages.txt"
#define TMP_HDRS	"headers.txt"
#define TMP_DENSE	"dense.txt"

int getncomp(char *string, int howmany, char *component);	
int decode(char *filename, int dstarea, int options);
int addnew(char *fullpath);
bint getfreespace(char *path);
int findmax(char *subject, int *this);
int checkfile(int areaid, char *filename);
int parse(int destarea, struct newsmsg *linebuf, int messages, int options);

//int comp(struct newsmsg *a, struct newsmsg *b)
int comp(const void *a, const void *b)
{
	struct newsmsg *tmp1=(struct newsmsg *)a;
	struct newsmsg *tmp2=(struct newsmsg *)b;

//	printf("COMP %s %s\n", a->subject, b->subject);
//	return(strcmp(a->subject,b->subject));
	return(strcmp(tmp1->subject,tmp2->subject));
}

int p_dlnews(char *server, char *groups, char *username, char *passwd, 
			int options, int wait_after, int wait_secs)
{
	FILE *fp, *dp;
	MYSQL_RES *sql_res;
	MYSQL_ROW sql_row;
	char tmpdir[PATH_MAX];
	char combuf[BUFFSIZE];
	char olddir[PATH_MAX];
	int densesize=0;
	char *hdrbuf;
	char grouppat[255];
//	char suckkillfile[PATH_MAX];
	int spaceleft=1;
	struct stat st;
	time_t timetemp;
	struct newsmsg *linebuf=NULL;
	char *value;
	int accepted_msgs;

	if(!server || !server[0])
		return(-1);

	if(!username || !passwd)
	{
		fprintf(stderr,
		"Urk, call p_dlnews() with empty username and passwd strings, not NULL!\n");
		return(-5);
	}

	strcpy(NNTPServer, server);

	if(groups && groups[0])
		strcpy(GroupString, groups);
	else
		GroupString[0]=0;

	if(options & OPT_NAZI)
		Nazi=1;
	if(options & OPT_VERBOSE)
		Verbose=1;

// Init some shit

	Filetypes[0]=0;
	value=p_getmisc(&dst_db, P_KEY_FILETYPES);
	if(value)
		strcpy(Filetypes, value);
	else
	{
		p_setmisc(&dst_db, P_KEY_FILETYPES, P_FILETYPES);
		strcpy(Filetypes, P_FILETYPES);
	}

	setlinebuf(stdout);
	setlinebuf(stderr);

	umask(002);

	value=p_getmisc(&dst_db, P_KEY_TMPDIR);
	if(!value)
		value=P_TMPDIR;

	getcwd(olddir, PATH_MAX);
	if(stat(value, &st)!=0)
		mkdir(value,0770);

	sprintf(tmpdir, "%s%spleech.%d",
		value, (p_checkp(value) ? "" : "/"),
		getpid());
	if(stat(tmpdir, &st)==0)
	{
		fprintf(stderr, "Ugh, %s exists. Remove it.\n",
				tmpdir); 
		return(-1);
	}
	mkdir(tmpdir,0770);
	chdir(tmpdir);

//	sprintf(suckkillfile, "%s%ssuckkillfile",
//			P_DATADIR, (p_checkp(P_DATADIR) ? "" : "/"));

	if(GroupString[0])			// Special match orders for group name?
	{
		sprintf(grouppat, "AND g_name like '%s'", 
				GroupString);
	}

	p_query(&dst_db, "SELECT g_name, g_last, area_path, area_id 
				FROM p_groups, p_areas
				WHERE g_dest=area_id
				%s
				AND NOT (g_flags & %ld)",
				(grouppat[0] ? grouppat : ""),
				GROUP_DISABLED);
	sql_res=mysql_store_result(&dst_db);
	if(!sql_res)
	{
		fprintf(stderr, "%s\n", mysql_error(&dst_db));
		return(-1);
	}

	if(mysql_num_rows(sql_res)<=0)
	{
		fprintf(stderr, "No (active) groups match the given patterns.\n");
		return(0);
	}

	while((sql_row=mysql_fetch_row(sql_res)))	// Read group info
	{
		char buffer[QUERY_MAX];
		char dirtmp[PATH_MAX];
		char groupname[255];
		int lastread,i,j,inc;
		int fd,destarea;
		int newlines=0;
		int dlerr;

		if(!spaceleft || !isalnum(sql_row[0][0]))	// Just a safety check
			continue;

		i=1;dirtmp[0]=0;
		while(getncomp(sql_row[2], i, dirtmp)) // Try to create the directories
		{
//			fprintf(stderr, "Creat: %s %d\n", dirtmp, i);
			mkdir(dirtmp, 0770);
			i++;
		}
	
		if(stat(sql_row[2], &st)!=0)
		{
			fprintf(stderr, "Unable to create %s\n", sql_row[2]);
			continue;
		}

		dp=fopen("sucknewsrc", "w");		// Create rc for Suck
		if(!dp)
		{
			fprintf(stderr,"Unable to create 'sucknewsrc' to %s\n", tmpdir);
			return(-1);
		}
		// Create groupline
		fprintf(dp, "%s %s\n", 
				sql_row[0], 
				((options & OPT_RESTART) ? "0" : sql_row[1]));
		fclose(dp);

		// Copy suckkillfile
		//if(stat(suckkillfile, &st)==0)
		//	p_cp(suckkillfile, ".");

		timetemp=time(NULL);
		printf("Date: %s", ctime(&timetemp));
		printf("Group: %s\n", sql_row[0]);
		destarea=atoi(sql_row[3]);

		printf("[PIMPPA] Downloading article headers\n");

		sprintf(combuf, "suck %s -c -g -dd %s "
						"%s%s "
						"%s%s "
						"%s >%s",
				NNTPServer, tmpdir, 
				(username[0] ? "-U " : ""), (username[0] ? username : ""),
				(passwd[0] ? "-P " : ""), (passwd[0] ? passwd : ""),
				((options & OPT_QUIET) ? "-q" : ""),
				TMP_HDRS);
		if(system(combuf)!=0)
		{
			fprintf(stderr, "[PIMPPA] nonzero suck exit status. Skipping.\n");
			unlink(TMP_HDRS);
			system("rm -f suck*");
			continue;
		}
		rename("sucknewsrc", "sucknewsrc.done");
		unlink("suckkillfile");		// Not needed anymore

		dp=fopen("sucknewsrc", "w");
		fclose(dp);

/***** Parse dled headers *****/

		printf("[PIMPPA] Sorting headers...\n");

		fp=fopen(TMP_HDRS, "r");
		if(!fp)
		{
			fprintf(stderr, "Unable to open %s for reading!\n", TMP_HDRS);
			continue;
		}
		dp=fopen(TMP_DENSE, "w");
		if(!dp)
		{
			fprintf(stderr, "Unable to open %s for writing!\n", TMP_DENSE);
			continue;
		}

		while((fgets(buffer, QUERY_MAX, fp)))
		{
			if(strncmp(buffer, "Subject: ", 9)==0)
				fprintf(dp, "S: %s", &buffer[9]);
			else
			{
				if(strncmp(buffer, "Message-ID: ", 12)==0)
					fprintf(dp, "I: %s", &buffer[12]);
			}
		}
		fclose(fp);
		fclose(dp);

//		sprintf(combuf, "grep -e \"^Subject:\\|^Message-ID:\" %s >%s", 
//			TMP_HDRS, TMP_DENSE);
		//	"headers2.txt", TMP_DENSE);
//		system(combuf);
	
		unlink(TMP_HDRS);			// Don't need this anymore

		if((fd=open(TMP_DENSE, O_RDWR))<0)
		{
			fprintf(stderr, "Unable to open %s for mmapping %d\n", TMP_DENSE, fd);
			continue;
		}
		fstat(fd, &st);
		densesize=st.st_size;
		if(densesize<=0)
		{
			close(fd);
			continue;
		}	

		hdrbuf=mmap(0, densesize, PROT_READ|PROT_WRITE, MAP_PRIVATE, fd, 0);
		if(hdrbuf==MAP_FAILED)
		{
			fprintf(stderr, "mmap() of %s failed\n", TMP_DENSE);
			close(fd);
			continue;
		}
//		hdrbuf[densesize]=0;

		newlines=0;
		// Find out newline count (messages=newlines/2)
		for(i=0;i<densesize;i++)
			if(hdrbuf[i]=='\n')
				newlines++;

		// Load subject,message_id pointers into a table
		linebuf=malloc((newlines/2)*sizeof(struct newsmsg));
	
		j=0;i=0;inc=0;
		while(j<newlines/2 && i<densesize)
		{
			if(hdrbuf[i]=='S')
			{
				inc++;
				linebuf[j].subject=&hdrbuf[i];
			}
			else
			{
				inc++;
				linebuf[j].id=&hdrbuf[i];
			}
			
			if(inc==2)
			{
				j++;
				inc=0;
			}
			
			while(hdrbuf[i]!='\n' && i<densesize)
				i++;
			if(hdrbuf[i]=='\n')
				hdrbuf[i]=0;
			i++;
//			printf("j, %s\n", linebuf[j].subject);
		}
		
//		printf("%d %d %d", i, j, newlines/2);
//		printf("New: %d\n", newlines);
//		printf("%s\n", linebuf[20].subject);

//		for(i=0;i<newlines/2;i++)
//			printf("%s\n", linebuf[i].subject);

		// Sort the subject,message_id table
		qsort(linebuf, newlines/2, sizeof(struct newsmsg), comp);

		printf("[PIMPPA] Parsing headers...\n");

		// Find out filenames, check if all parts are around,
		// skip bad looking messages, create suckothermsgs
		accepted_msgs=parse(destarea, linebuf,newlines/2,options);

		free(linebuf);
		if(munmap(hdrbuf, densesize))
			perror("kurr");
		close(fd);

		if(accepted_msgs<=0)
		{
			fprintf(stderr, "[PIMPPA] Nothing to download.\n");
			unlink(TMP_DENSE);
			unlink(TMP_MSGS);
			system("rm -f suck*");
			continue;
		}	

/***** Download good articles based on suckothermsgs ****/

		printf("[PIMPPA] Downloading articles...\n");
	
		sprintf(combuf, "suck %s -c -dd %s -W %d %d "
						"%s%s "
						"%s%s "
						"%s"
						"-w %d %d >%s",
				NNTPServer, tmpdir, wait_secs, wait_after,
				(username[0] ? "-U " : ""), (username[0] ? username : ""),
				(passwd[0] ? "-P " : ""), (passwd[0] ? passwd : ""),
				((options & OPT_QUIET) ? "-q " : ""),
				wait_secs*2, wait_after*2, TMP_MSGS);
//		fprintf(stderr, "%s\n", combuf);
		dlerr=system(combuf);						// Fetch messages
		if(dlerr)
			fprintf(stderr, "[PIMPPA] nonzero suck exit status. Not updating g_last ptr.\n");

		if(stat(TMP_MSGS, &st)==0 &&
			(bint)st.st_size>getfreespace(tmpdir))		// Check hd space
		{
			fprintf(stderr, "Eek, file larger than free space! Stopping.\n");
			spaceleft=0;
		}
	
		if(spaceleft)
			if(!decode(TMP_MSGS, destarea, options))// Decode the message file	
			{
				fprintf(stderr, "Critical error with decode to %s\n", sql_row[2]);
				return(-1);
			}

		if(!dlerr)
		{
			dp=fopen("sucknewsrc.done", "r");	// Get the modified rc line
			if(!dp)
			{
				fprintf(stderr, "Unable to open 'sucknewsrc.done' for reading...\n");
				return(-1);
			}
		
			fscanf(dp, "%s %d", groupname, &lastread);
			fclose(dp);

			p_query(&dst_db, "UPDATE p_groups SET g_last=%d
							WHERE g_name='%s'",
							lastread, groupname);
		}
		else
			system("rm -f suck*");

		printf("\n");

		unlink(TMP_DENSE);
		unlink("suckothermsgs");	
		unlink("sucknewsrc");
		unlink("sucknewsrc.done");
		unlink("sucknewsrc.old");
	}

	mysql_free_result(sql_res);

	if(spaceleft)
		unlink(TMP_MSGS);
		
	unlink(TMP_DENSE);
	unlink("suckothermsgs");	
	unlink("sucknewsrc");
	unlink("sucknewsrc.done");
	unlink("sucknewsrc.old");

	rmdir(tmpdir);
	chdir(olddir);
		
	timetemp=time(NULL);
	printf("Finished: %s\n", ctime(&timetemp));
	printf("Gained Files: %d\n\n",
			GainedFiles);
	fflush(stdout);

	return(0);
}

/*
 * Returns the n:th component of a string in style /joo/moo/muu
 *
 * NULL if none
 *
 */
int getncomp(char *string, int howmany, char *component)
{
	if(!string || !component)
		return(0);

	if(!string[0])
	{
		component[0]=0;
		return(0);
	}

//	printf("got: %d\n", howmany);

	while(*string!=0 && howmany>0)
	{
		if(string[0]=='/')
		{
			howmany--;
		}
		*component=*string;
		component++; string++;
	}

	*component=0;

	if(howmany==0)
		return(1);
	else
		return(0);
}

/*
 * Decodes the contents of file "filename" to dstarea
 *
 */
int decode(char *filename, int dstarea, int options)
{
	char curdir[PATH_MAX];
	char buffer[BUFFSIZE];
	char tmp_path[PATH_MAX];

	getcwd(curdir, PATH_MAX);
//	printf("cur: %s", curdir);

	sprintf(tmp_path, "%s%sdecode_tmp",
			curdir, (p_checkp(curdir) ? "" : "/"));	
	mkdir(tmp_path,0770);
	
	printf("[PIMPPA] Decoding to %s\n", tmp_path);
	fflush(stdout);
	
	sprintf(buffer, "uudeview -m -n -v -i -o -p %s %s >/dev/null", 
			tmp_path, filename);
	system(buffer);						// Decode to temp dir
//	fprintf(stderr, "%s\n", buffer);

	printf("[PIMPPA] Processing decoded files...\n");
	fflush(stdout);
	GainedFiles+=p_adopt(tmp_path, dstarea, options|OPT_MOVE|OPT_STATS);

	rmdir(tmp_path);
	
//	fprintf(stderr, "Result: %d\n", system(buffer));
	fflush(stdout);
	fflush(stderr);

	return(1);
}

/*
 * Returns free HD space
 *
 */
bint getfreespace(char *path)
{
	struct statfs freest;

	if(!statfs(path,&freest))
		return((bint)freest.f_bsize*(bint)freest.f_bavail);

	return(0);
}

int checkfile(int areaid, char *filename)
{
    int dval;

    if(strlen(filename)>=P_LEN_FILE_NAME)
        return(RESULT_LONG_FILENAME);

    if(!p_checkfilename(&dst_db, filename))
        return(RESULT_INVALID_FILENAME);

    dval=p_dupecheck(filename, areaid);
    if(dval>=0 && dval!=INTEG_FAILED)
        return(RESULT_FILE_EXISTS);

    dval=p_getdest(filename);
    if(dval<0)
        return(RESULT_ASSIGN_DELETE);

    if(Nazi && dval==0)
        return(RESULT_NAZI_KILL);

    return(RESULT_OK);
}

/*
 * This is a rather stupid fuck. If e.g. part 3 is missing
 * but there's a part 4 duplicate, it will think the posting 
 * complete and download. Also, it only understands messages 
 * to belong together only if their subjects follow each 
 * other when sorted.
 *
 */
int parse(int destarea, struct newsmsg *linebuf, int messages, int options)
{
	regex_t preq;
	regmatch_t pmatch[1];
	char fnamebuf[256];
	int gotsum=0;
	int laststart=0,lastend=0;
	int i=0,j=0,lincnt;
	int howmany=0;
	int maxparts=0;
	int accepted_msgs=0;
	FILE *dp;
	char *tmp, *oldtmp=NULL;
	
	dp=fopen("suckothermsgs", "w");
	if(!dp)
	{
		fprintf(stderr, "Unable to open suckothermsgs for writing\n");
		return(-1);
	}

	if(options & OPT_LENIENT)
	{
		printf("[PIMPPA] Using lenient mode, taking all articles...\n");

		for(i=0;i<messages;i++)
			fprintf(dp, "%s\n", &linebuf[i].id[3]); 
		fclose(dp);
		return(messages);
	}

	regcomp(&preq, Filetypes, REG_ICASE|REG_EXTENDED);

	lincnt=0;
	while(lincnt<messages)
	{
		howmany=1;
		tmp=linebuf[lincnt].subject;
		if(Verbose)
			printf("%s\n", tmp);
		i=0;
		oldtmp=NULL;
		// Find out the last matching filename
		while(regexec(&preq, tmp, 1, pmatch, 0)!=REG_NOMATCH)
		{
			laststart=pmatch[0].rm_so;
			lastend=pmatch[0].rm_eo;
			oldtmp=tmp;
			tmp=&tmp[lastend];
			gotsum=1;
		}
		
		if(oldtmp)
		{
			int chkval;
			int curpart;

			tmp=oldtmp;
			
			j=0;
			for(i=laststart;tmp[i]!=' ';i--);
			if(tmp[i]==' ') i++;
			while(i<lastend)
				fnamebuf[j++]=tmp[i++];
			fnamebuf[j]=0;

//			if(Verbose)
//				printf("  FILE %s\n", fnamebuf);

			maxparts=findmax(&tmp[i], &curpart);

			if(curpart==0)
				howmany=0;

			lincnt++;
			while(lincnt<messages && strstr(linebuf[lincnt].subject, fnamebuf))
			{
				lincnt++;
				howmany++;
			}
			
			chkval=checkfile(destarea, fnamebuf);
			if(chkval!=RESULT_OK)
			{
				if(Verbose)
					printf("  SKIP %s: %s\n", fnamebuf, Results[chkval]);
				continue;
			}
			
//			printf("  Found %d of %d pieces \n", howmany, maxparts);
			if(howmany>=maxparts)
			{
				int k;
				
				if(Verbose)
					printf("  TAKE %s (%d parts)\n",fnamebuf, 
						(maxparts ? maxparts : 1));
				for(k=howmany;k>0;k--)
				{
					fprintf(dp, "%s\n", &linebuf[lincnt-k].id[3]);
//					printf("  TAKE %s\n", linebuf[lincnt-k].id);
					accepted_msgs++;
				}
			}
			else
			{
				if(Verbose)
					printf("  ERROR, found only %d of %d parts\n", howmany, maxparts);
			}
		}
		else
		{
			lincnt++;
			if(Verbose)
				printf("  NOMATCH\n");
		}
	}

	fclose(dp);
	regfree(&preq);

	if(Verbose)
		printf("[PIMPPA] Accepted %d of %d articles\n", 
			accepted_msgs, messages);

	return(accepted_msgs);
}

/* 
 * Tries to find the maximum part amount of this subject
 * The current part is returned in *this.
 *
 */
int findmax(char *subject, int *this)
{
	regex_t parts;
	regmatch_t partmatch[1];
	char partscratch[256];
	int curpart,maxparts;
	int i,j;
	int gotparts;
	char *tmp=subject;

	curpart=gotparts=maxparts=0;

	regcomp(&parts, "\\([0-9]*/[0-9]*\\)|\\[[0-9]*/[0-9]*\\]", REG_ICASE|REG_EXTENDED);

//	printf("  LOOKFROM %s\n", subject);

	if(!regexec(&parts, tmp, 1, partmatch, 0))
	{
		j=0;
		for(i=partmatch[0].rm_so;i<partmatch[0].rm_eo;i++)
			partscratch[j++]=tmp[i];
		partscratch[j]=0;
		
//		printf("  SCRATCH: %s\n", partscratch);
		if(sscanf(partscratch, "(%d/%d)", &curpart, &maxparts)!=2)
		{
			sscanf(partscratch, "[%d/%d]", &curpart, &maxparts);
		}
//		printf("  FOUND part %d of %d\n", curpart, maxparts);
	}

	*this=curpart;

	regfree(&parts);
	return(maxparts);
}

